require_relative "player"

module VcsBkTdrRps
  class Game
    attr_reader :players

    def initialize(user_player)
      @winner = nil
      @user_player = user_player
      @comp_player = VcsBkTdrRps::Player.new("Computer", true)
      @players = [@user_player, @comp_player]
    end

    def throw_hands
      @players.each(&:set_hand)
    end

    def show_hands
      @players.each do |player|
        puts "#{player.name}'s hand was #{player.hand}"
      end
    end

    def show_winner
      if @winner == 'tie'
        puts 'It was a tie!'
      else
        puts "#{@winner} won!"
      end
    end

    def find_winner
      compare_hands(@user_player, @comp_player)
    end

    def play
      throw_hands
      @winner = find_winner
      show_hands
      show_winner
    end

    private

    def compare_hands(p1, p2)
      if p1.hand == p2.hand
        'tie'
      else
        case p1.hand
        when 'rock'
          p2.hand == 'paper' ? p2.name : p1.name
        when 'paper'
          p2.hand == 'scissors' ? p2.name : p1.name
        when 'scissors'
          p2.hand == 'rock' ? p2.name : p1.name
        end
      end
    end
  end
end
