module VcsBkTdrRps
  class Player
    CHOICES = %w[rock paper scissors].freeze
    attr_accessor :hand
    attr_reader :name

    def initialize(name, comp = false)
      @name = name
      @hand = false
      @comp = comp
    end

    def display_choices
      CHOICES.each_with_index { |choice, i| puts "#{i}: #{choice}" }
    end

    def set_hand
      @comp ? @hand = CHOICES.sample : @hand = throw_hand
    end

    private

    def valid_hand?(hand)
      CHOICES.include? hand.downcase
    end

    def throw_hand
      hand = 'wrong'
      until valid_hand?(hand)
        puts "Please choose the hand you want to throw..."
        display_choices
        hand = gets.chomp
      end
      hand
    end
  end
end